/*
* @Author: Bartuccio Antoine
* @Date:   2018-07-24 14:55:33
* @Last Modified by:   klmp200
* @Last Modified time: 2018-07-24 20:09:20
 */

package commands

import (
	"../shared"
	tb "gopkg.in/tucnak/telebot.v2"
	"strings"
)

func SetGender(m *tb.Message) {
	if m.Sender.Username == "" {
		shared.Bot.Send(m.Chat, "Il faut avoir enregistré un username pour pouvoir utiliser cette fonction")
		return
	}
	split := cleanGender(strings.Split(m.Text, " ")[1:])
	if len(split) == 0 {
		shared.Bot.Send(m.Chat, "Désolé, mais je n'ai pas compris.")
		return
	}
	data := strings.Join(split, " ")
	shared.Users.Set(m.Sender.Username, "gender", data)
	shared.Bot.Send(m.Chat, "Votre genre est enregistré, je vous considère maintenant comme « "+data+" ».")
}

func Gender(m *tb.Message) {
	data, exists := shared.Users.Get(m.Sender.Username, "gender")
	if !exists {
		shared.Bot.Send(m.Chat, "Vous n'avez pas enregistré votre genre, je ne voudrais pas l'assumer.")
	} else {
		shared.Bot.Send(m.Chat, data)
	}
}

func cleanGender(slice []string) []string {
	for i := range slice {
		clean := false
		for !clean {
			clean = true
			if strings.HasPrefix(slice[i], "@") {
				slice[i] = strings.Replace(slice[i], "@", "", 1)
				clean = false
			} else if strings.HasPrefix(slice[i], "/") {
				slice[i] = strings.Replace(slice[i], "/", "", 1)
				clean = false
			}
		}
	}
	return slice
}
